#include <cpctelera.h>
#include "book.h"
#include "id.h"
#include "player.h"
#include "renderer.h"
#include "assets/book.h"
#include "assets/obook.h"
#include "sprite.h"
#include "chapters.h"

#define BOOK_WIDTH  BOOKS_BOOK_W * 2
#define BOOK_HEIGHT BOOKS_BOOK_H

#define BOOK_CX     BOOK_WIDTH / 2
#define BOOK_CY     BOOK_HEIGHT

bool  book_isActive;
u8    book_id;
u16   book_x0, book_x1;
u8    book_y;
bool  book_isOpened;

void book_reset() {
  book_isActive = false;
  book_id = id_generate();
}

void book_start(u16 x, u8 y, bool opened) {
  book_isActive = true;
  book_x0 = x - BOOK_CX;
  book_x1 = x + BOOK_CY;
  book_y = y - BOOK_CY;
  book_isOpened = opened;
}

void book_step() {
  if (book_isActive && book_isOpened &&
      player_x > book_x0 && player_x < book_x1) {
    chapters_end();
  }
}

void book_drawer(void* payload, u16 x, u8 y) {
  u8* scr = renderer_getScreenPointer(x, y);
  u8* sprite = book_isOpened? obooks_obook: books_book;
  sprite_drawSprite(sprite, scr, BOOKS_BOOK_W, BOOKS_BOOK_H);
}

void book_render() {
  if (book_isActive &&
      renderer_isVisible(book_x0) && renderer_isVisible(book_x1)) {
    renderer_draw(book_id,
                  book_x0, book_y,
                  BOOK_WIDTH, BOOK_HEIGHT,
                  &book_drawer, (void*)0);
  }
}
