#ifndef _COLLIDER_H_
#define _COLLIDER_H_

#include <types.h>
#include "path.h"
#include "blocks.h"
#include "fixed.h"
#include "bool.h"

typedef struct {
  Path*   path;       // nearest path
  Path*   platform;   // nearest platform
  Block*  block;      // nearest block
  bool    onFloor;    // Is collider on path, platform or box?
  bool    onPath;
  bool    onPlatform;
  bool    onBlock;
  uf16    fx, fy;     // collision position
} Collider;

void collider_create(Collider* collider);
void collider_check(Collider* collider, u16 x0, u8 y0, u16 x1, u8 y1);
void collider_move(Collider* collider, uf16 fx, uf16 fy, f8 fdx);

#endif // _COLLIDER_H_
