;;
;; CRTC configuration
;;
;; References:
;; - CRTC documentation at http://www.cpcwiki.eu/index.php/CRTC

.equ WIDTH_IN_CHARS, #50
.equ HSYNC_START_IN_CHARS, #51
.equ HEIGHT_IN_CHARS, #20
.equ VSYNC_START_IN_CHARS, #28

.equ R3_HALF_CHAR, #86
.equ R3_COMPLETE_CHAR, #85

_setCRTC::
  ; R1: set horizontal displayed characters
  ld  bc, #0xbc01
  out (c), c
  ld  bc, #0xbd00 + WIDTH_IN_CHARS
  out (c), c

  ; R2: set horizontal sync position
  ld  bc, #0xbc02
  out (c), c
  ld  bc, #0xbd00 + HSYNC_START_IN_CHARS
  out (c), c

  ; R6: set vertical displayed characters
  ld  bc, #0xbc06
  out (c), c
  ld  bc, #0xbd00 + HEIGHT_IN_CHARS
  out (c), c

  ; R7: set vertical sync position
  ld  bc, #0xbc07
  out (c), c
  ld  bc, #0xbd00 + VSYNC_START_IN_CHARS
  out (c), c

  ret

_setR30::
  ld  bc, #0xbc03
  out (c), c
  ld  bc, #0xbd00 + R3_HALF_CHAR
  out (c), c
  ret

_setR31::
  ld  bc, #0xbc03
  out (c), c
  ld  bc, #0xbd00 + R3_COMPLETE_CHAR
  out (c), c
  ret
