#include "entities.h"
#include "scene.h"
#include "dogs.h"
#include "blocks.h"
#include "player.h"
#include "book.h"
#include "rain.h"
#include "guardian.h"
#include "next_chapter.h"
#include "renderer.h"

void entities_init() {
  player_init();
  dogs_init();
  guardian_init();
}

void entities_reset(u8 chapter) {
  Entity* entity = scene_entities;

  renderer_reset();
  dogs_reset();
  blocks_reset();
  rain_reset();
  book_reset();
  nextChapter_reset();

  for (u8 i = 0; i < SCENE_ENTITY_COUNT; i++, entity++) {
    if (entity->chapter == 255 || entity->chapter == chapter) {
      u16 x = entity->x;
      u8  y = entity->y;
      switch (entity->type) {
        case 0: player_reset(x, y); break;
        case 1: clowns_add(x, y); break;
        case 2: dogs_add(x, y); break;
        case 3: blocks_add(x, y, true, true); break;
        case 4: blocks_add(x, y, false, false); break;
        case 5: book_start(x, y, false); break;
        case 6: rain_start(); break;
        case 7: book_start(x, y, true); break;
        case 8: guardian_start(x, y, chapter); break;
        case 9: nextChapter_start(x); break;
      }
    }
  }
}
