#include <cpctelera.h>
#include "scene.h"
#include "fader.h"

#define FADE_DECREMENT  3

u8  fader_palette[16];

void fader_init() {
  for (u8 i = 0; i < 16; i++) {
    fader_palette[i] = scene_palette[i];
  }
}

void fader_wait() {
  for (u8 i = 0; i < 2; i++) {
    __asm__("halt");
    __asm__("halt");
    cpct_waitVSYNC();
  }
}

void fader_fade(u8 decrement, i8 displacement) {
  u8  faded[16];
  for (u8 i = 0; i < 16; i++) {
    faded[i] = fader_palette[i];
  }

  while (decrement >= 0 && decrement <= 27) {
    for (u8 i = 0; i < 16; i++) {
      u8  color = fader_palette[i];
      faded[i] = color > decrement? color - decrement: 0;
    }

    cpct_fw2hw(faded, 16);
    cpct_setPalette(faded, 16);

    decrement += displacement;

    fader_wait();
  }
}

void fader_fadeOut() {
  cpct_akp_stop();
  // TODO fade out music cpct_akp_setFadeVolume
  fader_fade(0, 3);
}

void fader_fadeIn() {
  // TODO fade in music cpct_akp_setFadeVolume
  fader_fade(27, -3);
}
