
; Cálculo del puntero a la dirección de vídeo
; return: renderer_screen + 100 * (y >> 3) + 2048 * (y % 8) + xInBytes
; Funciona para cualquier screen con 100 bytes de ancho de pantalla

; IN  -> xInBytes / line_number
; OUT -> 16-bit Pointer -> HL
; Global variables used -> u8* screen
; __z88dk_callee __smallc convention needed


; T -> 49 us

_getScreenPointerAsm::
	pop		hl
	ex		(sp),hl		; L <- line number / H <- xInBytes ; __smallc -> left-to-right order

	ld		e,h

	ld		a,l
	and		#7			; A = y mod 8
	ld		h,a
	xor		l			; 8(Y >> 3) | CY <- 0
	ld		l,a
	rra					; 4(Y >> 3)

	ld		b,#0
	ld		c,a
	add		hl,bc		; 8(Y >> 3) + 4(Y >> 3) + 256(y % 8)
	add		hl,hl		; 16(Y >> 3) + 8(Y >> 3) + 512(y % 8)
	add		hl,hl		; 32(Y >> 3) + 16(Y >> 3) + 1024(y % 8)
	add		hl,hl		; 64(Y >> 3) + 32(Y >> 3) + 2048(y % 8)
	add		e			; 4(Y >> 3) + xInBytes

	ld		de,(#_renderer_screen)
	add		hl,de		; 64(Y >> 3) + 32(Y >> 3) + 2048(y % 8) + Screen
	ld		c,a
	add		hl,bc		; 64(Y >> 3) + 32(Y >> 3) + 4(Y >> 3) + 2048(y % 8) + Screen + xInBytes
						; = 100(Y >> 3) + 2048( y % 8) + Screen + xInBytes
						; SIMD instructions FTW!
	ret
