#include <cpctelera.h>
#include "scene.h"
// ./json2map.sh ../art/maps/map.json -n scene -o ../cpc/src/
#include "sprite.h"
#include "renderer.h"
#include "fader.h"
#include "player.h"
#include "path.h"
#include "blocks.h"
#include "dogs.h"
#include "guardian.h"
#include "book.h"
#include "rain.h"
#include "next_chapter.h"
#include "debug.h"
#include "sprites.h"
// ./json2spr.sh ../art/sprites/sprites.json -n sprites -p 0,14,4,15,5,1,26,13,6,2,23,3,8 -o ../cpc/src/ -a 0x9000 -c
#include "chapters.h"
#include "assets/song.h"

i8 getMovement() {
  i8 d;

  i16 center = player_x - SCREEN_WIDTH / 2;
  if (center < 0) center = 0;
  else if (center > SCENE_SPAN_COUNT * 4 - SCREEN_WIDTH) center = SCENE_SPAN_COUNT * 4 - SCREEN_WIDTH;

  d = (i8)((i16)(center >> 1) - (i16)(renderer_fineScroll));
  if (d > 2) d = 2;
  else if (d < -2) d = -2;

  return d;
}

void checkDebugKeys() {
  // if (cpct_isKeyPressed(Key_Return)) {
  //   for (u16 i = 0; i < 200; i++) {
  //     __asm__("halt");
  //   }
  // }
  //
  // if (cpct_isKeyPressed(Key_C)) {
  //   u8 frame = cpct_px2byteM0(0, 0);
  //   cpct_memset(CPCT_VMEM_START, frame, 0x4000);
  // }
  //
  // if (cpct_isKeyPressed(Key_R)) {
  //   renderer_clearAll();
  // }
  //
  // if (cpct_isKeyPressed(Key_Q)) {
  //   chapters_next();
  // }
  //
  // if (cpct_isKeyPressed(Key_A)) {
  //   chapters_previous();
  // }
  //
  // if (cpct_isKeyPressed(Key_P)) {
  //   debug_drawVisiblePaths(scene_paths, SCENE_PATH_COUNT);
  //   debug_drawVisiblePaths(scene_platforms, SCENE_PLATFORM_COUNT);
  // }
}

void start(void) {
  i8 movement = 0;

  renderer_init();
  fader_init();

  debug_init();
  cpct_akp_musicInit(song);

  sprite_init();

  entities_init();
  chapters_set(0);

  while (1) {
    // Start new frame
    // debug_setBorder(HW_WHITE);
    renderer_begin();

    cpct_scanKeyboard_f();
    checkDebugKeys();

    // Schedule clearing dirty zones
    dogs_clear();
    rain_clear();
    if (player_isVisible()) {
      player_clear();
    }

    // Update logic
    // debug_setBorder(HW_BRIGHT_WHITE);
    dogs_step();
    player_step();
    rain_step();
    book_step();
    guardian_step();
    nextChapter_step();
    movement = getMovement();
    renderer_updateScroll(movement);

    // Schedule drawing entities
    // debug_setBorder(HW_WHITE);
    dogs_render();
    blocks_render();
    rain_render();
    book_render();
    guardian_render();
    if (player_isVisible()) {
      player_render();
    }

    // End frame: clears old dirty zones, perform scroll and draw entities
    // debug_resetBorder();
    renderer_end();
  }
}

void main(void) {
  cpct_disableFirmware();

  start();
}
