#include <cpctelera.h>
#include "print.h"
#include "font.h"
// ./png2font.sh ../art/sprites/chars2.png -n font -o ../cpc/src/

#define PRINT_MIN_CHAR  48
#define PRINT_MAX_CHAR  PRINT_MIN_CHAR + FONT_CHARS

u8  print_masks[FONT_PATTERNS * 4];

u8 print_encodeAnd(u8 a, u8 b) {
  return cpct_px2byteM0(a == 0? 0xf: 0, b == 0? 0xf: 0);
}
u8 print_encodeOr(u8 a, u8 b, u8 color) {
  return cpct_px2byteM0(a == 2? color: 0, b == 2? color: 0);
}

void print_setColor(u8 color) {
  u8* src = font_patterns;
  u8* dst = print_masks;
  u8  counter = FONT_PATTERNS;
  u8  current, a, b, c, d;

  while (counter--) {
    current = *src++;
    a = current & 0b11; current = current >> 2;
    b = current & 0b11; current = current >> 2;
    c = current & 0b11; current = current >> 2;
    d = current & 0b11;
    *dst++ = print_encodeAnd(a, b);
    *dst++ = print_encodeOr(a, b, color);
    *dst++ = print_encodeAnd(c, d);
    *dst++ = print_encodeOr(c, d, color);
  }
}

void print_drawChar(u8* dst, char ch) {
  const u8* src;
  u8        index;
  u8        height;

  if (ch < PRINT_MIN_CHAR || ch > PRINT_MAX_CHAR) {
    return;
  }

  index = ch - PRINT_MIN_CHAR;
  src = &font_data[index * FONT_HEIGHT];
  height = FONT_HEIGHT;

  while (height--) {
    const u8* pattern = &print_masks[*src++];

    *dst = *dst & *pattern++ | *pattern++;
    *dst++;
    *dst = *dst & *pattern++ | *pattern;
    *dst--;

    if (height) {
      dst += 0x800;
      if (dst < (u8*)0x800 ) {
        dst += 0xc064;
      }
    }
  }
}

u8 print_stringLength(char* string) {
  u8 result = 0;
  while (*(string++) != 0) result++;
  return result;
}

void print_drawString(u8* scr, char* string) {
  char ch;
  scr -= print_stringLength(string);
  while (ch = *string++) {
    print_drawChar(scr, ch);
    scr += 2;
  }
}
