#ifndef _RENDERER_H_
#define _RENDERER_H_

#include <types.h>

#define SCREEN_WIDTH 200
#define SCREEN_WITH_IN_BYTES 100
#define SCREEN_WITH_IN_CHARS 50
#define SCREEN_HEIGHT 160

extern u8* renderer_screen;
extern u16 renderer_scroll;
extern u16 renderer_fineScroll;

void renderer_init(void);
void renderer_reset();
void renderer_center(u16 x);
void renderer_clearAll();

void renderer_begin();
void renderer_clear(u8 id, u16 x, u8 y, u8 width, u8 height);
void renderer_updateScroll(i8 movement);
void renderer_forceRedraw(u8 id);
void renderer_draw(u8 id, u16 x, u8 y, u8 width, u8 height,
                   void (*drawer)(void*, u16, u8), void* payload);
void renderer_end();

extern u8* getScreenPointerAsm(u8 xInBytes, u8 y) __z88dk_callee __smallc;
u8*  renderer_getScreenPointer(u16 wx, u8 wy);
u8   renderer_isVisible(u16 wx);

#endif // _RENDERER_H_
