; DrawPartialSpanAsm

; IN  -> *screen / *span / y / height
; OUT -> void
; __z88dk_callee convention needed in function definition

.include "macros.s"

_renderer_drawPartialSpanAsmFast::
	pop		af				; dirección retorno
	exx
		pop		hl			; screen pointer HL
		ld		e,#08		; Precálculo para sumar 0x800
	exx						; La opción de precalcular 0xC064 para el ADD HL,DE no es tan rápida
							; como la anterior ya que se ejecuta un % bajo de las veces

	pop		hl 				; span poniter
	pop		bc				; B <- height / C <- y
	push	af 				; dirección de retorno de vuelta a la pila

	push	ix

	ld		a,c				; A <- y
	ld		de,#3

sigue_buscando:
	ld		c,(hl)			; C <- counter
	add		hl,de			; apuntamos al siguiente (HL+3)
	sub		c
	jr		nc,sigue_buscando
	dec		hl
	dec		hl
	neg
	ld		c,a
	ld		a,b

otro_elemento:
	ld		d,(hl)
	inc		hl
	ld		e,(hl)
	inc		hl

	cp		c
	jr		nc,no_counter_update
	ld		c,a
no_counter_update:

	ld__ixl_c
	push	de
	exx
	pop		bc
	ex		af,af			; A <-> A'

rep_counter:
	ld		(hl),b
	inc		l
	ld		(hl),c
	dec 	l

	ld		a,e				; Precalculado 08 -> E ahorramos 1us en cada iteración
	add		h
	ld		h,a
	jr		nc,no_cambio_bloque_caracteres
	ld		de,#0xC064
	add		hl,de
	ld		e,#8			; Restauramos el precalc de +0x800

no_cambio_bloque_caracteres:
	dec__ixl
	jr		nz,rep_counter

	exx
	ex		af,af			; A <-> A'
	sub		c
	ld		c,(hl)
	inc		hl
	jr		nz,otro_elemento

	pop		ix

	ret
