#ifndef _SCENE_H_
#define _SCENE_H_

#include <types.h>
#include "entities.h"

#define SCENE_SPAN_WIDTH 4
#define SCENE_SPAN_HEIGHT 80
#define SCENE_SPAN_WIDTH_IN_BYTES 2

#define SCENE_ENTITY_COUNT 35
#define SCENE_BLOCK_COUNT 16
#define SCENE_DOG_COUNT 5
#define SCENE_SPAN_COUNT 512
#define SCENE_PATH_COUNT 35
#define SCENE_PLATFORM_COUNT 32

extern const u8 scene_chapters[91];

extern const Entity scene_entities[SCENE_ENTITY_COUNT];

extern const u8 scene_palette[13];

extern const u16 scene_topHalfIndices[SCENE_SPAN_COUNT];
extern const u16 scene_bottomHalfIndices[SCENE_SPAN_COUNT];

extern const u8 scene_spans[10332];

extern const Path scene_paths[SCENE_PATH_COUNT];
extern const Path scene_platforms[SCENE_PLATFORM_COUNT];

#endif // _SCENE_H_
