#ifndef _SPRITES_H_
#define _SPRITES_H_

#include <types.h>

#define SPRITES_BASE 36864
#define SPRITES_DATA_COUNT 2493

extern const __at(SPRITES_BASE) u8 sprites_data[SPRITES_DATA_COUNT];

#define PLAYER_RUNNING_WIDTH  10
#define PLAYER_RUNNING_HEIGHT 30
#define PLAYER_RUNNING_COUNT  6
#define PLAYER_RUNNING_SPRITE_0 0
#define PLAYER_RUNNING_SPRITE_1 1
#define PLAYER_RUNNING_SPRITE_2 2
#define PLAYER_RUNNING_SPRITE_3 3
#define PLAYER_RUNNING_SPRITE_4 4
#define PLAYER_RUNNING_SPRITE_5 5

#define PLAYER_STANDING_WIDTH  6
#define PLAYER_STANDING_HEIGHT 29
#define PLAYER_STANDING_COUNT  1
#define PLAYER_STANDING_SPRITE_0 6

#define PLAYER_JUMPING_WIDTH  10
#define PLAYER_JUMPING_HEIGHT 30
#define PLAYER_JUMPING_COUNT  2
#define PLAYER_JUMPING_SPRITE_0 7
#define PLAYER_JUMPING_SPRITE_1 8

#define PLAYER_PULLING_WIDTH  10
#define PLAYER_PULLING_HEIGHT 27
#define PLAYER_PULLING_COUNT  2
#define PLAYER_PULLING_SPRITE_0 9
#define PLAYER_PULLING_SPRITE_1 10

#define PLAYER_FLYING_WIDTH  8
#define PLAYER_FLYING_HEIGHT 32
#define PLAYER_FLYING_COUNT  1
#define PLAYER_FLYING_SPRITE_0 11

#define PLAYER_CLIMBING_WIDTH  12
#define PLAYER_CLIMBING_HEIGHT 25
#define PLAYER_CLIMBING_COUNT  6
#define PLAYER_CLIMBING_SPRITE_0 12
#define PLAYER_CLIMBING_SPRITE_1 13
#define PLAYER_CLIMBING_SPRITE_2 14
#define PLAYER_CLIMBING_SPRITE_3 15
#define PLAYER_CLIMBING_SPRITE_4 16
#define PLAYER_CLIMBING_SPRITE_5 17

#define DOG_SLEEPING_WIDTH  16
#define DOG_SLEEPING_HEIGHT 12
#define DOG_SLEEPING_COUNT  1
#define DOG_SLEEPING_SPRITE_0 18

#define DOG_STANDING_WIDTH  16
#define DOG_STANDING_HEIGHT 18
#define DOG_STANDING_COUNT  1
#define DOG_STANDING_SPRITE_0 19

#define DOG_RUNNING_WIDTH  20
#define DOG_RUNNING_HEIGHT 22
#define DOG_RUNNING_COUNT  4
#define DOG_RUNNING_SPRITE_0 20
#define DOG_RUNNING_SPRITE_1 21
#define DOG_RUNNING_SPRITE_2 22
#define DOG_RUNNING_SPRITE_3 23

#define CLOWN_WALKING_WIDTH  16
#define CLOWN_WALKING_HEIGHT 24
#define CLOWN_WALKING_COUNT  4
#define CLOWN_WALKING_SPRITE_0 24
#define CLOWN_WALKING_SPRITE_1 25
#define CLOWN_WALKING_SPRITE_2 26
#define CLOWN_WALKING_SPRITE_3 27

#define RAIN_DROP_WIDTH  2
#define RAIN_DROP_HEIGHT 4
#define RAIN_DROP_COUNT  1
#define RAIN_DROP_SPRITE_0 28

#define RAIN_SPLASH_WIDTH  4
#define RAIN_SPLASH_HEIGHT 2
#define RAIN_SPLASH_COUNT  1
#define RAIN_SPLASH_SPRITE_0 29

extern void (*sprites_drawers[30])(u8* scr) __z88dk_fastcall;

#endif // _SPRITES_H_
