// #include <cpctelera.h>
#include <string.h>
#include "uncompress.h"
#include "imagen_exo.h"

#define G_SCENE_W 100
#define deexo 0x5000


// from crtc.s 
extern void setCRTC(void);

const u8 blackPalette[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
const u8 colorPalette[16] = {0, 1, 23, 11, 4, 13, 26, 15, 14, 7, 17, 5, 22, 10, 6, 0};

void drawScene(u8* scr) {
  u8 x = 0;
  for (u8 y = 0; y < 160; y++) {
    u8* destination = scr + 100 * (y >> 3) + 2048 * (y % 8) + x;
    u8* source = deexo + y * G_SCENE_W;
    memcpy(destination, source, G_SCENE_W);
  }
}

void setColor(unsigned char nColorIndex, unsigned char nPaletteIndex) {
  __asm
    push ix
    ld ix,#0 
    add ix,sp
    ld a, 4 (ix)
    ld b, 5 (ix)
    ld c, b
    call #0xBC32 ;SCR SET INK
    pop ix
  __endasm;
}

void setPalette(const unsigned char *pPalette, u8 nColors) {
  unsigned char nColor = 0;

  for(nColor = 0; nColor < nColors; nColor++)
    setColor(nColor, pPalette[nColor]);
}

u8 main(void) {
  u16 *pScreen = (unsigned char *)0xC000;

    // Mode 0
  __asm
    ld a, #0
    call #0xBC0E
  __endasm;

  //SCR SET BORDER 0
  __asm
    ld b, #0 ;black
    ld c, b
    call #0xBC38
  __endasm;

  // overscan
  setCRTC();

  // clear screen
  setPalette(blackPalette,16);

  uncompress(imagen_exo_bin, deexo);
  
  // draw image
  drawScene(pScreen);

  setPalette(colorPalette,15);
  return 0;
}
